com.smartgwt.client.widgets.form.fields

## Class DateRangeItem

- java.lang.Object
- - com.smartgwt.client.core.JsObject
  - - com.smartgwt.client.core.DataClass
    - - com.smartgwt.client.core.RefDataClass
      - - com.smartgwt.client.widgets.form.fields.FormItem
        - - com.smartgwt.client.widgets.form.fields.CanvasItem
          - - com.smartgwt.client.widgets.form.fields.DateRangeItem

- All Implemented Interfaces:
    com.google.gwt.event.shared.HasHandlers, HasBlurHandlers, HasCanEditChangedHandlers, HasChangedHandlers, HasChangeHandlers, HasClickHandlers, HasDoubleClickHandlers, HasEditorEnterHandlers, HasEditorExitHandlers, HasFocusHandlers, HasIconClickHandlers, HasIconKeyPressHandlers, HasItemHoverHandlers, HasKeyDownHandlers, HasKeyPressHandlers, HasKeyUpHandlers, HasPickerIconClickHandlers, HasShowValueHandlers, HasTitleClickHandlers, HasTitleDoubleClickHandlers, HasTitleHoverHandlers, HasValueHoverHandlers

      public class DateRangeItem
      extends CanvasItem

  Allows a user to select an absolute or relative range of dates via two `RelativeDateItem`s (if `allowRelativeDates` is true) or two `DateItems`.

  DateRangeItem is just a convenience relative to using two `RelativeDateItem` or `DateItem` controls in a form, then using `operator` and `criteriaField` to cause them to produce a date range. If you need more control over layout, validation, event handling or any other aspect of appearance or behavior, stop using DateRangeItem and use two DateItem/RelativeDateItem controls directly instead.

- - ### Field Summary

    - ### Fields inherited from class com.smartgwt.client.core.RefDataClass

      `id`

    - ### Fields inherited from class com.smartgwt.client.core.JsObject

      `jsObj`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `DateRangeItem()`
    `DateRangeItem(com.google.gwt.core.client.JavaScriptObject jsObj)`
    `DateRangeItem(java.lang.String name)`
    `DateRangeItem(java.lang.String name, java.lang.String title)`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `static void` | `changeAutoChildDefaults(java.lang.String autoChildName, Canvas defaults)` Changes the defaults for Canvas AutoChildren named `autoChildName`.
    `static void` | `changeAutoChildDefaults(java.lang.String autoChildName, FormItem defaults)` Changes the defaults for FormItem AutoChildren named `autoChildName`.
    `static void` | `changePickerIconDefaults(FormItemIcon defaults)`
    `java.lang.Boolean` | `getAllowRelativeDates()` Whether to allow the user to specify relative dates (via `RelativeDateItem`s) or whether dates are absolute (via `DateItem`s).
    `java.util.Date` | `getFromDate()` Initial value for the "from" date.
    `FormItem` | `getFromField()` The field for the "from" date - a `RelativeDateItem` or `DateItem` according to `allowRelativeDates`.
    `java.lang.String` | `getFromTitle()` The title for the `from` part of the range.
    `TitleOrientation` | `getInnerTitleOrientation()` The title orientation for the to / from sub-items.
    `java.lang.String` | `getInputFormat()` For fields of type `"date"`, if this is an editable field such as a `TextItem`, this property allows you to specify the `inputFormat` applied to the item.
    `java.lang.String` | `getInvalidRangeErrorMessage()` Error message to display if the user enters a date range where the "To" field value is earlier than the "From" field value.
    `static DateRangeItem` | `getOrCreateRef(com.google.gwt.core.client.JavaScriptObject jsObj)`
    `java.lang.Boolean` | `getShouldSaveValue()` Allow dateRangeItems' values to show up in the form's values array, or if `DynamicForm.getValuesAsCriteria` is called, for the criterion to be included in the returned AdvancedCriteria object
    `java.util.Date` | `getToDate()` Initial value for the "to" date.
    `FormItem` | `getToField()` The field for the "to" date - a `RelativeDateItem` or `DateItem` according to `allowRelativeDates`.
    `java.lang.String` | `getToTitle()` The title for the `to` part of the range.
    `java.lang.Boolean` | `getValidateCriteria()` If this attribute is set to `true` when `getCriteria` is called, the item will validate the "to" and "from" fields and return null if either field fails validation.
    `DateRange` | `getValue()` Retrieves the current value of this dateRangeItem.
    `java.lang.Boolean` | `hasAdvancedCriteria()` Overridden to return true: dateRangeItems always generate AdvancedCriteria.
    `void` | `setAllowRelativeDates(java.lang.Boolean allowRelativeDates)` Whether to allow the user to specify relative dates (via `RelativeDateItem`s) or whether dates are absolute (via `DateItem`s).
    `void` | `setCanEditCriterionPredicate(FormItemCanEditCriterionPredicate predicate)` The default `canEditCriterion()` predicate returns true if the specified criterion contains: A single "lessOrEqual" or "greaterOrEqual" criterion on this field An "and" type criterion containing a "lessOrEqual" and a "greaterOrEqual" criterion on this field A single "equals" criterion.
    `void` | `setCriterionSetter(FormItemCriterionSetter setter)` The default `setCriterion()` implementation applies the specified criterion to this item for editing.
    `static void` | `setDefaultProperties(DateRangeItem dateRangeItemProperties)` Class level method to set the default properties of this class.
    `void` | `setFromDate(java.util.Date fromDate)` Initial value for the "from" date.
    `void` | `setFromTitle(java.lang.String fromTitle)` The title for the `from` part of the range.
    `void` | `setInnerTitleOrientation(TitleOrientation innerTitleOrientation)` The title orientation for the to / from sub-items.
    `void` | `setInputFormat(java.lang.String inputFormat)` For fields of type `"date"`, if this is an editable field such as a `TextItem`, this property allows you to specify the `inputFormat` applied to the item.
    `void` | `setInvalidRangeErrorMessage(java.lang.String invalidRangeErrorMessage)` Error message to display if the user enters a date range where the "To" field value is earlier than the "From" field value.
    `void` | `setJavaScriptObject(com.google.gwt.core.client.JavaScriptObject jsObj)`
    `void` | `setShouldSaveValue(java.lang.Boolean shouldSaveValue)` Allow dateRangeItems' values to show up in the form's values array, or if `DynamicForm.getValuesAsCriteria` is called, for the criterion to be included in the returned AdvancedCriteria object
    `void` | `setToDate(java.util.Date toDate)` Initial value for the "to" date.
    `void` | `setToDate(java.lang.String toDate)` Initial value for the "to" date.
    `void` | `setToDate(TimeUnit toDate)` Initial value for the "to" date.
    `void` | `setToTitle(java.lang.String toTitle)` The title for the `to` part of the range.
    `void` | `setValidateCriteria(java.lang.Boolean validateCriteria)` If this attribute is set to `true` when `getCriteria` is called, the item will validate the "to" and "from" fields and return null if either field fails validation.
    `void` | `setValue(DateRange value)` Sets the value for this dateRangeItem.
    `java.lang.Boolean` | `validateRange()` Validate both "to" and "from" date-fields.

    - ### Methods inherited from class com.smartgwt.client.widgets.form.fields.CanvasItem

      `addCanEditChangedHandler, addShowValueHandler, createCanvas, getApplyPromptToCanvas, getAutoDestroy, getCanvas, getEditCriteriaInInnerForm, getHeight, getMultiple, getOverflow, getPrompt, readOnlyDisplayChanged, setApplyPromptToCanvas, setAutoDestroy, setCanvas, setCriterionGetter, setDefaultProperties, setEditCriteriaInInnerForm, setMultiple, setOverflow, setPrompt, setupCanvasConstructor, storeValue, storeValue, storeValue`

    - ### Methods inherited from class com.smartgwt.client.widgets.form.fields.FormItem

      `_getValue, addBlurHandler, addChangedHandler, addChangeHandler, addClickHandler, addDoubleClickHandler, addEditorEnterHandler, addEditorExitHandler, addFocusHandler, addIconClickHandler, addIconKeyPressHandler, addItemHoverHandler, addKeyDownHandler, addKeyPressHandler, addKeyUpHandler, addPickerIconClickHandler, addTitleClickHandler, addTitleDoubleClickHandler, addTitleHoverHandler, addValueHoverHandler, asSGWTComponent, blurItem, canEditCriterion, clearValue, disable, enable, focusInItem, getAccessKey, getAlign, getAllowExpressions, getAlwaysFetchMissingValues, getApplyHeightToTextBox, getAriaRole, getAttribute, getAttributeAsBoolean, getAttributeAsDate, getAttributeAsDouble, getAttributeAsFloat, getAttributeAsInt, getAttributeAsJavaScriptObject, getAttributeAsString, getBrowserSpellCheck, getCanEdit, getCanFocus, getCanvasAutoChild, getCellHeight, getCellStyle, getClassName, getClipStaticValue, getClipTitle, getConfig, getContainerWidget, getCriteriaField, getCriterion, getCriterion, getDataPath, getDateFormatter, getDecimalPad, getDecimalPrecision, getDefaultIconSrc, getDisabled, getDisableIconsOnReadOnly, getDisplayField, getDisplayFieldName, getDisplayValue, getDisplayValue, getEditorTypeConfig, getEditPendingCSSText, getEmptyDisplayValue, getEmptyValueIcon, getEndRow, getErrorIconHeight, getErrorIconSrc, getErrorIconWidth, getErrorMessageWidth, getFetchMissingValues, getFieldName, getFilterLocally, getForm, getFormItemAutoChild, getFullDataPath, getGlobalTabIndex, getHint, getHintStyle, getHoverAlign, getHoverDelay, getHoverHeight, getHoverOpacity, getHoverStyle, getHoverVAlign, getHoverWidth, getIcon, getIconHeight, getIconHSpace, getIconPageRect, getIconPrompt, getIconRect, getIconVAlign, getIconWidth, getImageURLPrefix, getImageURLSuffix, getImplicitSave, getImplicitSaveOnBlur, getLeft, getLocateItemBy, getMultipleValueSeparator, getName, getOperator, getOptionCriteria, getOptionFilterContext, getOptionOperationId, getPageLeft, getPageRect, getPageTop, getPicker, getPickerIconHeight, getPickerIconName, getPickerIconPrompt, getPickerIconProperties, getPickerIconSrc, getPickerIconStyle, getPickerIconWidth, getPrintTextBoxStyle, getPrintTitleStyle, getReadOnlyDisplay, getReadOnlyTextBoxStyle, getRect, getRedrawOnChange, getRejectInvalidValueOnChange, getRequired, getRequiredMessage, getRowSpan, getSaveOnEnter, getSelectedRecord, getSelectOnClick, getSelectOnFocus, getShowClippedTitleOnHover, getShowClippedValueOnHover, getShowDisabled, getShowErrorIcon, getShowErrorStyle, getShowErrorText, getShowFocused, getShowFocusedErrorState, getShowFocusedIcons, getShowFocusedPickerIcon, getShowHint, getShowIcons, getShowOverIcons, getShowPickerIcon, getShowRTL, getShowTitle, getShowValueIconOnly, getStartRow, getStopOnError, getSuppressValueIcon, getSynchronousValidation, getTabIndex, getTextAlign, getTextBoxStyle, getTimeFormatter, getTitle, getTitleAlign, getTitleColSpan, getTitleOrientation, getTitleStyle, getTitleVAlign, getTooltip, getTop, getType, getValidateOnChange, getValidateOnExit, getValidOperators, getVAlign, getValueAsRecordList, getValueField, getValueFieldName, getValueIconHeight, getValueIconLeftPadding, getValueIconRightPadding, getValueIconSize, getValueIconWidth, getVisible, getVisibleHeight, getVisibleWidth, getWidth, getWrapTitle, hide, hideIcon, invalidateDisplayValueCache, isCreated, isDisabled, isDrawn, isVisible, redraw, setAccessKey, setAlign, setAllowExpressions, setAlwaysFetchMissingValues, setApplyHeightToTextBox, setAriaRole, setAriaState, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAutoChildConstructor, setAutoChildProperties, setAutoChildProperties, setAutoChildVisibility, setBrowserSpellCheck, setCanEdit, setCanFocus, setCellHeight, setCellStyle, setClipStaticValue, setClipTitle, setColSpan, setColSpan, setCriteriaField, setCriterion, setDataPath, setDateFormatter, setDecimalPad, setDecimalPrecision, setDefaultIconSrc, setDefaultProperties, setDefaultValue, setDefaultValue, setDefaultValue, setDefaultValue, setDefaultValue, setDefaultValue, setDefaultValue, setDisabled, setDisableIconsOnReadOnly, setDisplayField, setDisplayFormat, setDisplayFormat, setEditorProperties, setEditorType, setEditorType, setEditorType, setEditorValueFormatter, setEditorValueParser, setEditPendingCSSText, setEmptyDisplayValue, setEmptyValueIcon, setEndRow, setErrorFormatter, setErrorIconHeight, setErrorIconSrc, setErrorIconWidth, setErrorMessageWidth, setErrorOrientation, setFetchMissingValues, setFilterLocally, setGlobalTabIndex, setHeight, setHeight, setHint, setHintStyle, setHoverAlign, setHoverDelay, setHoverHeight, setHoverOpacity, setHoverStyle, setHoverVAlign, setHoverWidth, setIconHeight, setIconHSpace, setIconPrompt, setIcons, setIconVAlign, setIconWidth, setImageURLPrefix, setImageURLSuffix, setImplicitSave, setImplicitSaveOnBlur, setInitHandler, setInputTransformer, setItemHoverFormatter, setItemTitleHoverFormatter, setItemValueHoverFormatter, setLeft, setLocateItemBy, setMultipleValueSeparator, setName, setOperator, setOptionCriteria, setOptionDataSource, setOptionFilterContext, setOptionOperationId, setPickerIconHeight, setPickerIconName, setPickerIconPrompt, setPickerIconProperties, setPickerIconSrc, setPickerIconStyle, setPickerIconWidth, setPrintTextBoxStyle, setPrintTitleStyle, setProperty, setProperty, setProperty, setProperty, setProperty, setReadOnlyDisplay, setReadOnlyTextBoxStyle, setRedrawOnChange, setRejectInvalidValueOnChange, setRequired, setRequiredMessage, setRowSpan, setSaveOnEnter, setSelectOnClick, setSelectOnFocus, setShowClippedTitleOnHover, setShowClippedValueOnHover, setShowDisabled, setShowErrorIcon, setShowErrorStyle, setShowErrorText, setShowFocused, setShowFocusedErrorState, setShowFocusedIcons, setShowFocusedPickerIcon, setShowHint, setShowIcons, setShowIfCondition, setShowOverIcons, setShowPickerIcon, setShowRTL, setShowTitle, setShowValueIconOnly, setStartRow, setStopOnError, setSuppressValueIcon, setSynchronousValidation, setTabIndex, setTextAlign, setTextBoxStyle, setTimeFormatter, setTitle, setTitleAlign, setTitleColSpan, setTitleHoverFormatter, setTitleOrientation, setTitleStyle, setTitleVAlign, setTooltip, setTop, setType, setValidateOnChange, setValidateOnExit, setValidators, setValidOperators, setVAlign, setValue, setValue, setValue, setValue, setValue, setValue, setValueField, setValueFormatter, setValueHoverFormatter, setValueIconHeight, setValueIconLeftPadding, setValueIconMapper, setValueIconRightPadding, setValueIcons, setValueIconSize, setValueIconWidth, setValueMap, setValueMap, setVisible, setWidth, setWidth, setWrapTitle, shouldApplyHeightToTextBox, shouldFetchMissingValue, shouldSaveOnEnter, show, showIcon, showPicker, stopHover, updateState, validate, valueClipped`

    - ### Methods inherited from class com.smartgwt.client.core.RefDataClass

      `getRef, getRef, internalSetID`

    - ### Methods inherited from class com.smartgwt.client.core.DataClass

      `doAddHandler, fireEvent, getAttributeAsDoubleArray, getAttributeAsIntArray, getAttributeAsLong, getAttributeAsMap, getAttributeAsObject, getAttributeAsRecord, getAttributeAsStringArray, getAttributes, getHandlerCount, getJsObj, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttributeAsJavaObject`

    - ### Methods inherited from class com.smartgwt.client.core.JsObject

      `equals, hashCode, setJsObj`

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface com.google.gwt.event.shared.HasHandlers

      `fireEvent`

- - ### Constructor Detail

    - #### DateRangeItem

          public DateRangeItem()

    - #### DateRangeItem

          public DateRangeItem(com.google.gwt.core.client.JavaScriptObject jsObj)

    - #### DateRangeItem

          public DateRangeItem(java.lang.String name)

    - #### DateRangeItem

          public DateRangeItem(java.lang.String name,
                       java.lang.String title)

  - ### Method Detail

    - #### getOrCreateRef

          public static DateRangeItem getOrCreateRef(com.google.gwt.core.client.JavaScriptObject jsObj)

    - #### setJavaScriptObject

          public void setJavaScriptObject(com.google.gwt.core.client.JavaScriptObject jsObj)

      Overrides:
        `setJavaScriptObject` in class `CanvasItem`

    - #### changeAutoChildDefaults

          public static void changeAutoChildDefaults(java.lang.String autoChildName,
                                     Canvas defaults)

      Changes the defaults for Canvas AutoChildren named `autoChildName`.
      Parameters:
        `autoChildName` - name of an AutoChild to customize the defaults for.
        `defaults` - Canvas defaults to apply. These defaults override any existing properties without destroying or wiping out non-overridden properties.
      See Also:
        `AutoChildUsage`

    - #### changeAutoChildDefaults

          public static void changeAutoChildDefaults(java.lang.String autoChildName,
                                     FormItem defaults)

      Changes the defaults for FormItem AutoChildren named `autoChildName`.
      Parameters:
        `autoChildName` - name of an AutoChild to customize the defaults for.
        `defaults` - FormItem defaults to apply. These defaults override any existing properties without destroying or wiping out non-overridden properties.
      See Also:
        `AutoChildUsage`

    - #### changePickerIconDefaults

          public static void changePickerIconDefaults(FormItemIcon defaults)

    - #### setAllowRelativeDates

          public void setAllowRelativeDates(java.lang.Boolean allowRelativeDates)

      Whether to allow the user to specify relative dates (via `RelativeDateItem`s) or whether dates are absolute (via `DateItem`s).
      Parameters:
        `allowRelativeDates` - allowRelativeDates Default value is false

    - #### getAllowRelativeDates

          public java.lang.Boolean getAllowRelativeDates()

      Whether to allow the user to specify relative dates (via `RelativeDateItem`s) or whether dates are absolute (via `DateItem`s).
      Returns:
        Boolean

    - #### getFromField

          public FormItem getFromField()

      The field for the "from" date - a `RelativeDateItem` or `DateItem` according to `allowRelativeDates`.

      For an overview of how to use and configure AutoChildren, see `Using AutoChildren`.

      Returns:
        FormItem

    - #### setFromTitle

          public void setFromTitle(java.lang.String fromTitle)

      The title for the `from` part of the range.
      Parameters:
        `fromTitle` - . See `String`. Default value is "From"

    - #### getFromTitle

          public java.lang.String getFromTitle()

      The title for the `from` part of the range.
      Returns:
        . See `String`

    - #### setInnerTitleOrientation

          public void setInnerTitleOrientation(TitleOrientation innerTitleOrientation)

      The title orientation for the to / from sub-items. If unset this will be derived from `this.titleOrientation` or `this.form.titleOrientation`.
      Parameters:
        `innerTitleOrientation` - innerTitleOrientation Default value is null

    - #### getInnerTitleOrientation

          public TitleOrientation getInnerTitleOrientation()

      The title orientation for the to / from sub-items. If unset this will be derived from `this.titleOrientation` or `this.form.titleOrientation`.
      Returns:
        TitleOrientation

    - #### setInputFormat

          public void setInputFormat(java.lang.String inputFormat)

      For fields of type `"date"`, if this is an editable field such as a `TextItem`, this property allows you to specify the `inputFormat` applied to the item.
      Overrides:
        `setInputFormat` in class `FormItem`
      Parameters:
        `inputFormat` - . See `DateInputFormat`. Default value is null
      See Also:
        `FormItem.setDateFormatter(com.smartgwt.client.types.DateDisplayFormat)`

    - #### getInputFormat

          public java.lang.String getInputFormat()

      For fields of type `"date"`, if this is an editable field such as a `TextItem`, this property allows you to specify the `inputFormat` applied to the item.
      Overrides:
        `getInputFormat` in class `FormItem`
      Returns:
        . See `DateInputFormat`
      See Also:
        `FormItem.getDateFormatter()`

    - #### setInvalidRangeErrorMessage

          public void setInvalidRangeErrorMessage(java.lang.String invalidRangeErrorMessage)

      Error message to display if the user enters a date range where the "To" field value is earlier than the "From" field value.
      Parameters:
        `invalidRangeErrorMessage` - . See `String`. Default value is '"To" field value cannot be earlier than "From" field value.'

    - #### getInvalidRangeErrorMessage

          public java.lang.String getInvalidRangeErrorMessage()

      Error message to display if the user enters a date range where the "To" field value is earlier than the "From" field value.
      Returns:
        . See `String`

    - #### setShouldSaveValue

          public void setShouldSaveValue(java.lang.Boolean shouldSaveValue)

      Allow dateRangeItems' values to show up in the form's values array, or if `DynamicForm.getValuesAsCriteria` is called, for the criterion to be included in the returned AdvancedCriteria object
      Overrides:
        `setShouldSaveValue` in class `CanvasItem`
      Parameters:
        `shouldSaveValue` - shouldSaveValue Default value is true

    - #### getShouldSaveValue

          public java.lang.Boolean getShouldSaveValue()

      Allow dateRangeItems' values to show up in the form's values array, or if `DynamicForm.getValuesAsCriteria` is called, for the criterion to be included in the returned AdvancedCriteria object
      Overrides:
        `getShouldSaveValue` in class `CanvasItem`
      Returns:
        Boolean

    - #### setToDate

          public void setToDate(java.util.Date toDate)

      Initial value for the "to" date.
      If this method is called after the component has been drawn/initialized: Sets the `toDate` for this DateRangeItem.
      Parameters:
        `toDate` - the date at which this item should end it's range. Default value is today

    - #### getToDate

          public java.util.Date getToDate()

      Initial value for the "to" date.
      Returns:
        Date

    - #### setToDate

          public void setToDate(java.lang.String toDate)

      Initial value for the "to" date.
      If this method is called after the component has been drawn/initialized: Sets the `toDate` for this DateRangeItem.
      Parameters:
        `toDate` - the date at which this item should end it's range. See `RelativeDateString`. Default value is today

    - #### setToDate

          public void setToDate(TimeUnit toDate)

      Initial value for the "to" date.
      If this method is called after the component has been drawn/initialized: Sets the `toDate` for this DateRangeItem.
      Parameters:
        `toDate` - the date at which this item should end it's range. Default value is today

    - #### getToField

          public FormItem getToField()

      The field for the "to" date - a `RelativeDateItem` or `DateItem` according to `allowRelativeDates`.

      For an overview of how to use and configure AutoChildren, see `Using AutoChildren`.

      Returns:
        FormItem

    - #### setToTitle

          public void setToTitle(java.lang.String toTitle)

      The title for the `to` part of the range.
      Parameters:
        `toTitle` - . See `String`. Default value is "To"

    - #### getToTitle

          public java.lang.String getToTitle()

      The title for the `to` part of the range.
      Returns:
        . See `String`

    - #### setValidateCriteria

          public void setValidateCriteria(java.lang.Boolean validateCriteria)

      If this attribute is set to `true` when `getCriteria` is called, the item will validate the "to" and "from" fields and return null if either field fails validation. See `DateRangeItem.validateRange`
      Parameters:
        `validateCriteria` - validateCriteria Default value is false

    - #### getValidateCriteria

          public java.lang.Boolean getValidateCriteria()

      If this attribute is set to `true` when `getCriteria` is called, the item will validate the "to" and "from" fields and return null if either field fails validation. See `DateRangeItem.validateRange`
      Returns:
        Boolean

    - #### hasAdvancedCriteria

          public java.lang.Boolean hasAdvancedCriteria()

      Overridden to return true: dateRangeItems always generate AdvancedCriteria.
      Overrides:
        `hasAdvancedCriteria` in class `CanvasItem`
      Returns:
        true
      See Also:
        `CriteriaEditing overview and related methods`

    - #### validateRange

          public java.lang.Boolean validateRange()

      Validate both "to" and "from" date-fields.
      Returns:
        false if either to or from field contains an invalid date value.

    - #### setDefaultProperties

          public static void setDefaultProperties(DateRangeItem dateRangeItemProperties)

      Class level method to set the default properties of this class. If set, then all subsequent instances of this class will automatically have the default properties that were set when this method was called. This is a powerful feature that eliminates the need for users to create a separate hierarchy of subclasses that only alter the default properties of this class. Can also be used for skinning / styling purposes.

      Note: This method is intended for setting default attributes only and will effect all instances of the underlying class (including those automatically generated in JavaScript). This method should not be used to apply standard EventHandlers or override methods for a class - use a custom subclass instead.

      Parameters:
        `dateRangeItemProperties` - properties that should be used as new defaults when instances of this class are created

    - #### setFromDate

          public void setFromDate(java.util.Date fromDate)

      Initial value for the "from" date. Sets the `fromDate` for this DateRangeItem.
      Parameters:
        `fromDate` - the date from which this item should start it's range. Default value is today

    - #### getFromDate

          public java.util.Date getFromDate()

      Initial value for the "from" date.
      Returns:
        java.util.Date

    - #### getValue

          public DateRange getValue()

      Retrieves the current value of this dateRangeItem. The return value is a `DateRange` object that excludes start and end values if they aren't set.
      Overrides:
        `getValue` in class `FormItem`
      Returns:
        the current value of this item

    - #### setValue

          public void setValue(DateRange value)

      Sets the value for this dateRangeItem. The value parameter is a `DateRange` object that optionally includes both start and end values.
      Parameters:
        `value` - the new value for this item

    - #### setCanEditCriterionPredicate

          public void setCanEditCriterionPredicate(FormItemCanEditCriterionPredicate predicate)

      The default `canEditCriterion()` predicate returns true if the specified criterion contains:
      - A single "lessOrEqual" or "greaterOrEqual" criterion on this field
      - An "and" type criterion containing a "lessOrEqual" and a "greaterOrEqual" criterion on this field
      - A single "equals" criterion. Internally, this will be converted into a range by constructing an "and" type criterion containing both a "lessOrEqual" and a "greaterOrEqual" criterion on this field. Note that subsequent calls to the `FormItemCriterionGetter`'s `getCriterion()` method will return this more complex criterion.
      Overrides:
        `setCanEditCriterionPredicate` in class `CanvasItem`
      Parameters:
        `predicate` - the predicate to determine the form items that can edit the criterion in question
      See Also:
        `FormItem.setCanEditCriterionPredicate`, `CriteriaEditing overview and related methods`

    - #### setCriterionSetter

          public void setCriterionSetter(FormItemCriterionSetter setter)

      The default `setCriterion()` implementation applies the specified criterion to this item for editing. Applies any specified "greaterOrEqual" operator criterion or sub-criterion to our `fromField` and any specified "lessOrEqual" operator criterion or sub-criterion to our `toField`.

      Note that a single "equals" criterion can also be passed. See `setCanEditCriterionPredicate()` for more detail.

      Overrides:
        `setCriterionSetter` in class `CanvasItem`
      Parameters:
        `setter` - provides a method to update this field with the edited criterion